Add mail config sanity check
[discourse_docker.git] / launcher
1 #!/bin/bash
2
3 command=$1
4 config=$2
5 opt=$3
6
7 # Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
8 re='[A-Z/ !@#$%^&*()+~`=]'
9 if [[ $config =~ $re ]];
10 then
11 echo
12 echo "ERROR: Config name must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
13 echo
14 exit 1
15 fi
16
17 cd "$(dirname "$0")"
18
19 docker_min_version='1.6.0'
20 docker_rec_version='1.6.0'
21
22 config_file=containers/"$config".yml
23 cidbootstrap=cids/"$config"_bootstrap.cid
24 local_discourse=local_discourse
25 image=discourse/discourse:1.0.17
26 docker_path=`which docker.io || which docker`
27
28
29 if [ "${SUPERVISED}" = "true" ]; then
30 restart_policy="--restart=no"
31 attach_on_start="-a"
32 attach_on_run="-a stdout -a stderr"
33 else
34 attach_on_run="-d"
35 fi
36
37 if [ -n "$DOCKER_HOST" ]; then
38 docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
39 elif [ -x "$(which ip 2>/dev/null)" ]; then
40 docker_ip=`ip addr show docker0 | \
41 grep 'inet ' | \
42 awk '{ split($2,a,"/"); print a[1] }';`
43 else
44 docker_ip=`ifconfig | \
45 grep -B1 "inet addr" | \
46 awk '{ if ( $1 == "inet" ) { print $2 } else if ( $2 == "Link" ) { printf "%s:" ,$1 } }' | \
47 grep docker0 | \
48 awk -F: '{ print $3 }';`
49 fi
50
51
52 usage () {
53 echo "Usage: launcher COMMAND CONFIG [--skip-prereqs]"
54 echo "Commands:"
55 echo " start: Start/initialize a container"
56 echo " stop: Stop a running container"
57 echo " restart: Restart a container"
58 echo " destroy: Stop and remove a container"
59 echo " enter: Use nsenter to enter a container"
60 echo " ssh: Start a bash shell in a running container"
61 echo " logs: Docker logs for container"
62 echo " bootstrap: Bootstrap a container for the config based on a template"
63 echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
64 echo " cleanup: Remove all containers that have stopped for > 24 hours"
65 echo
66 echo "Options:"
67 echo " --skip-prereqs Don't check prerequisites or resource requirements"
68 echo " --docker-args Extra arguments to pass when running docker"
69 exit 1
70 }
71
72 compare_version() {
73 declare -a ver_a
74 declare -a ver_b
75 IFS=. read -a ver_a <<< "$1"
76 IFS=. read -a ver_b <<< "$2"
77
78 while [[ -n $ver_a ]]; do
79 if (( ver_a > ver_b )); then
80 return 0
81 elif (( ver_b > ver_a )); then
82 return 1
83 else
84 unset ver_a[0]
85 ver_a=("${ver_a[@]}")
86 unset ver_b[0]
87 ver_b=("${ver_b[@]}")
88 fi
89 done
90 return 1 # They are equal
91 }
92
93 prereqs() {
94
95 # 1. docker daemon running?
96 # we send stderr to /dev/null cause we don't care about warnings,
97 # it usually complains about swap which does not matter
98 test=`$docker_path info 2> /dev/null`
99
100 if [[ $? -ne 0 ]] ; then
101 echo "Cannot connect to the docker daemon - verify it is running and you have access"
102 exit 1
103 fi
104
105 # 2. running aufs or btrfs
106 test=`$docker_path info 2> /dev/null | grep 'Driver: '`
107 if [[ "$test" =~ [aufs|btrfs|zfs|overlay] ]] ; then : ; else
108 echo "Your Docker installation is not using a supported filesystem if we were to proceed you may have a broken install."
109 echo "aufs is the recommended filesystem you should be using (zfs/btrfs and overlay may work as well)"
110 echo "You can tell what filesystem you are using by running \"docker info\" and looking at the driver"
111 echo ""
112 echo "If you wish to continue anyway using your existing unsupported filesystem"
113 echo "read the source code of launcher and figure out how to bypass this."
114 exit 1
115 fi
116
117 # 3. running recommended docker version
118 test=($($docker_path --version)) # Get docker version string
119 test=${test[2]//,/} # Get version alone and strip comma if exists
120
121 [[ "$test" =~ "0.12.0" ]] && echo "You are running a broken version of Docker, please upgrade ASAP. See: https://meta.discourse.org/t/the-installation-stopped-in-the-middle/16311/ for more details." && exit 1
122
123 # At least minimum version
124 if compare_version "${docker_min_version}" "${test}"; then
125 echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
126 exit 1
127 fi
128
129 # Recommend best version
130 if compare_version "${docker_rec_version}" "${test}"; then
131 echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
132 fi
133
134 # 4. discourse docker image is downloaded
135 test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
136
137 if [ -z "$test" ]; then
138 echo
139 echo "WARNING: We are about to start downloading the Discourse base image"
140 echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
141 echo
142 echo "Please be patient"
143 echo
144
145 fi
146
147 # 5. able to attach stderr / out / tty
148 test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
149 if [[ "$test" =~ "working" ]] ; then : ; else
150 echo "Your Docker installation is not working correctly"
151 echo
152 echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
153 exit 1
154 fi
155
156 }
157
158 check_resources() {
159 # Memory
160 resources="ok"
161 avail_mem="$(LANG=C free -m | grep '^Mem:' | awk '{print $2}')"
162 if [ "$avail_mem" -lt 900 ]; then
163 resources="insufficient"
164 echo "WARNING: You do not appear to have sufficient memory to run Discourse."
165 echo
166 echo "Your system may not work properly, or future upgrades of Discourse may"
167 echo "not complete successfully."
168 echo
169 echo "See https://github.com/discourse/discourse/blob/master/docs/INSTALL-cloud.md#create-new-cloud-server"
170 elif [ "$avail_mem" -lt 1800 ]; then
171 total_swap="$(LANG=C free -m | grep ^Swap: | awk '{print $2}')"
172 if [ "$total_swap" -lt 1000 ]; then
173 resources="insufficient"
174 echo "WARNING: You must have at least 1GB of swap when running with less"
175 echo "than 2GB of RAM."
176 echo
177 echo "Your system may not work properly, or future upgrades of Discourse may"
178 echo "not complete successfully."
179 echo
180 echo "See https://github.com/discourse/discourse/blob/master/docs/INSTALL-cloud.md#set-up-swap-if-needed"
181 fi
182 fi
183
184 # Disk space
185 free_disk="$(df /var | tail -n 1 | awk '{print $4}')"
186 if [ "$free_disk" -lt 5000 ]; then
187 resources="insufficient"
188 echo "WARNING: You must have at least 5GB of *free* disk space to run Discourse."
189 echo
190 echo "Insufficient disk space may result in problems running your site, and may"
191 echo "not even allow Discourse installation to complete successfully."
192 echo
193 echo "Please free up some space, or expand your disk, before continuing."
194 exit 1
195 fi
196
197 if [ -t 0 ] && [ "$resources" != "ok" ]; then
198 echo
199 read -p "Press ENTER to continue, or Ctrl-C to exit and give your system more resources"
200 fi
201 }
202
203 check_ports() {
204 local valid=$(netstat -tln | awk '{print $4}' | grep ":${1}\$")
205
206 if [ -n "$valid" ]; then
207 echo "Launcher has detected that port ${1} is in use."
208 echo ""
209 echo "If you are trying to run Discourse simultaneously with another web server like Apache or nginx, you will need to bind to a different port."
210 echo "See https://meta.discourse.org/t/17247 for help."
211 echo "To continue anyway, re-run Launcher with --skip-prereqs"
212 exit 1
213 fi
214 }
215
216 if [ "$opt" != "--skip-prereqs" ] ; then
217 prereqs
218 fi
219
220 if [ "$opt" == "--docker-args" ] ; then
221 user_args=$4
222 else
223 user_args=""
224 fi
225
226 get_ssh_pub_key() {
227 local ${ssh_key_locations}
228 ssh_key_locations=(
229 ~/.ssh/id_ed25519.pub
230 ~/.ssh/id_ecdsa.pub
231 ~/.ssh/id_rsa.pub
232 ~/.ssh/id_dsa.pub
233 ~core/.ssh/authorized_keys
234 )
235
236 local $keyfile
237 for keyfile in "${ssh_key_locations[@]}"; do
238 if [[ -e ${keyfile} ]] ; then
239 ssh_pub_key="$(cat ${keyfile})"
240 return 0
241 fi
242 done
243
244 return 0
245 }
246
247
248 install_docker() {
249
250 echo "Docker is not installed, you will need to install Docker in order to run Discourse"
251 echo "Please visit https://docs.docker.com/installation/ for instructions on how to do this for your system"
252 echo
253 echo "If you are running Ubuntu Trusty or later, you can try the following:"
254 echo
255
256 echo "sudo apt-key adv --keyserver hkp://p80.pool.sks-keyservers.net:80 --recv-keys 58118E89F3A912897C070ADBF76221572C52609D"
257 echo "sudo sh -c \"echo deb https://apt.dockerproject.org/repo ubuntu-$(lsb_release -sc) main > /etc/apt/sources.list.d/docker.list\""
258 echo "sudo apt-get update"
259 echo "sudo apt-get install docker-engine"
260
261 exit 1
262 }
263
264 host_run() {
265 read -r -d '' env_ruby << 'RUBY'
266 require 'yaml'
267
268 input = STDIN.readlines.join
269 yaml = YAML.load(input)
270
271 if host_run = yaml['host_run']
272 params = yaml['params'] || {}
273 host_run.each do |run|
274 params.each do |k,v|
275 run = run.gsub("$#{k}", v)
276 end
277 STDOUT.write "#{run}--SEP--"
278 end
279 end
280 RUBY
281
282 host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
283
284 while [ "$host_run" ] ; do
285 iter=${host_run%%--SEP--*}
286 echo
287 echo "Host run: $iter"
288 $iter || exit 1
289 echo
290 host_run="${host_run#*--SEP--}"
291 done
292 }
293
294
295 set_volumes() {
296 volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
297 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
298 }
299
300 set_links() {
301 links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
302 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
303 }
304
305 set_template_info() {
306
307 templates=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
308 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
309
310
311 arrTemplates=(${templates// / })
312 config_data=$(cat $config_file)
313
314 input="hack: true"
315
316 for template in "${arrTemplates[@]}"
317 do
318 [ ! -z $template ] && {
319 input="$input _FILE_SEPERATOR_ $(cat $template)"
320 }
321 done
322
323 # we always want our config file last so it takes priority
324 input="$input _FILE_SEPERATOR_ $config_data"
325
326 read -r -d '' env_ruby << 'RUBY'
327 require 'yaml'
328
329 input=STDIN.readlines.join
330 # default to UTF-8 for the dbs sake
331 env = {'LANG' => 'en_US.UTF-8'}
332 input.split('_FILE_SEPERATOR_').each do |yml|
333 yml.strip!
334 begin
335 env.merge!(YAML.load(yml)['env'] || {})
336 rescue Psych::SyntaxError => e
337 puts e
338 puts "*ERROR."
339 rescue => e
340 puts yml
341 p e
342 end
343 end
344 puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
345 RUBY
346
347 raw=`exec echo "$input" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
348
349 env=()
350 ok=1
351 while read i; do
352 if [ "$i" == "*ERROR." ]; then
353 ok=0
354 elif [ -n "$i" ]; then
355 env[${#env[@]}]=$i
356 fi
357 done <<< "$raw"
358
359 if [ "$ok" -ne 1 ]; then
360 echo "${env[@]}"
361 echo "YAML syntax error. Please check your /var/discourse/containers/*.yml config files."
362 exit 1
363 fi
364 }
365
366 [ -z $docker_path ] && {
367 install_docker
368 }
369
370 [ "$command" == "cleanup" ] && {
371 echo
372 echo "The following command will"
373 echo "- Delete all docker images for old containers"
374 echo "- Delete all stopped and orphan containers"
375 echo
376 read -p "Are you sure (Y/n): " -n 1 -r && echo
377 if [[ $REPLY =~ ^[Yy]$ || ! $REPLY ]]
378 then
379 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
380 echo "Starting Cleanup (bytes free $space)"
381
382 STATE_DIR=./.gc-state scripts/docker-gc
383
384 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
385 echo "Finished Cleanup (bytes free $space)"
386
387 else
388 exit 1
389 fi
390 exit 0
391 }
392
393 [ $# -lt 2 ] && {
394 usage
395 }
396
397 if [ ! -e $config_file ]
398 then
399 echo "Config file was not found, ensure $config_file exists"
400 echo ""
401 echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
402 exit 1
403 fi
404
405 docker_version=($($docker_path --version))
406 docker_version=${test[2]//,/}
407
408 if compare_version "1.2.0" "$docker_version"; then
409 echo "We recommend you upgrade docker, the version you are running has no restart policies, on reboot your container may not start up"
410 restart_policy=""
411 else
412 restart_policy=${restart_policy:---restart=always}
413 fi
414
415 set_existing_container(){
416 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
417 }
418
419 run_stop(){
420
421 set_existing_container
422
423 if [ ! -z $existing ]
424 then
425 (
426 set -x
427 $docker_path stop -t 10 $config
428 )
429 else
430 echo "$config was not started !"
431 exit 1
432 fi
433 }
434
435 set_run_image() {
436 run_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
437 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['run_image']"`
438
439 if [ -z "$run_image" ]; then
440 run_image="$local_discourse/$config"
441 fi
442 }
443
444 set_boot_command() {
445 boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
446 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['boot_command']"`
447
448 if [ -z "$boot_command" ]; then
449
450 no_boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
451 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['no_boot_command']"`
452
453 if [ -z "$no_boot_command" ]; then
454 boot_command="/sbin/boot"
455 fi
456 fi
457 }
458
459 run_start(){
460
461 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
462 echo $existing
463 if [ ! -z $existing ]
464 then
465 echo "Nothing to do, your container has already started!"
466 exit 1
467 fi
468
469 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
470 if [ ! -z $existing ]
471 then
472 echo "starting up existing container"
473 (
474 set -x
475 $docker_path start $config
476 )
477 exit 0
478 fi
479
480 host_run
481 ports=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
482 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| \"-p #{p}\"}.join(' ')"`
483
484 IFS='-p ' read -a array <<< "$ports"
485 for element in "${array[@]}"
486 do
487 IFS=':' read -a args <<< "$element"
488 if [ "${#args[@]}" == "2" ]; then
489 check_ports "${args[0]}"
490 elif [ "${#args[@]}" == "3" ]; then
491 check_ports "${args[1]}"
492 fi
493 done
494
495 docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
496 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
497
498 set_template_info
499 set_volumes
500 set_links
501 set_run_image
502 set_boot_command
503
504 # get hostname and settings from container configuration
505 for envar in "${env[@]}"
506 do
507 if [[ $envar == DOCKER_USE_HOSTNAME* ]] || [[ $envar == DISCOURSE_HOSTNAME* ]]
508 then
509 # use as environment variable
510 eval $envar
511 fi
512 done
513
514 (
515 hostname=`hostname -s`
516 # overwrite hostname
517 if [ "$DOCKER_USE_HOSTNAME" = "true" ]
518 then
519 hostname=$DISCOURSE_HOSTNAME
520 else
521 hostname=$hostname-$config
522 fi
523
524 # we got to normalize so we only have allowed strings, this is more comprehensive but lets see how bash does first
525 # hostname=`$docker_path run $user_args --rm $image ruby -e 'print ARGV[0].gsub(/[^a-zA-Z-]/, "-")' $hostname`
526 # docker added more hostname rules
527 hostname=${hostname/_/-}
528
529 set -x
530 $docker_path run $user_args $links $attach_on_run $restart_policy "${env[@]}" -h "$hostname" \
531 -e DOCKER_HOST_IP=$docker_ip --name $config -t $ports $volumes $docker_args $run_image $boot_command
532
533 )
534 exit 0
535
536 }
537
538 mail_config_check(){
539 mail_config_verbose=0 # 1 prints mail config to stdout
540 mail_config="ok"
541 for x in DISCOURSE_SMTP_ADDRESS DISCOURSE_SMTP_USER_NAME DISCOURSE_SMTP_PASSWORD \
542 DISCOURSE_SMTP_PORT DISCOURSE_SMTP_ENABLE_START_TLS
543 do
544 mail_var=`grep "^ $x:" $config_file`
545 result=$?
546 if (( result == 0 ))
547 then
548 if [ "$mail_config_verbose" -eq 1 ]; then
549 echo "$mail_var"
550 fi
551 else
552 echo "Warning: $x not configured."
553 mail_config="dubious"
554 fi
555 done
556 if [ -t 0 ] && [ "$mail_config" != "ok" ]; then
557 echo
558 read -p "Press ENTER to continue, or Ctrl-C to exit and fix your mail config."
559 fi
560 }
561
562 run_bootstrap(){
563
564 if [ "$opt" != "--skip-prereqs" ] ; then
565 check_resources
566 fi
567
568 mail_config_check
569
570 host_run
571
572 get_ssh_pub_key
573
574 # Is the image available?
575 # If not, pull it here so the user is aware what's happening.
576 $docker_path history $image >/dev/null 2>&1 || $docker_path pull $image
577
578 set_template_info
579
580 base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
581 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
582
583 update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
584 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
585
586 if [[ ! X"" = X"$base_image" ]]; then
587 image=$base_image
588 fi
589
590 set_volumes
591 set_links
592
593 rm -f $cidbootstrap
594
595 run_command="cd /pups &&"
596 if [[ ! "false" = $update_pups ]]; then
597 run_command="$run_command git pull &&"
598 fi
599 run_command="$run_command /pups/bin/pups --stdin"
600
601 echo $run_command
602
603 env=("${env[@]}" "-e" "SSH_PUB_KEY=$ssh_pub_key")
604
605 (exec echo "$input" | $docker_path run $user_args $links "${env[@]}" -e DOCKER_HOST_IP=$docker_ip --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
606 /bin/bash -c "$run_command") \
607 || ($docker_path rm `cat $cidbootstrap` && rm $cidbootstrap)
608
609 [ ! -e $cidbootstrap ] && echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one" && exit 1
610
611 sleep 5
612
613 $docker_path commit `cat $cidbootstrap` $local_discourse/$config || echo 'FAILED TO COMMIT'
614 $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
615 }
616
617
618
619 case "$command" in
620 bootstrap)
621 run_bootstrap
622 echo "Successfully bootstrapped, to startup use ./launcher start $config"
623 exit 0
624 ;;
625
626 enter)
627 exec $docker_path exec -it $config /bin/bash --login
628 ;;
629
630 ssh)
631 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
632
633 if [[ ! -z $existing ]]; then
634 address="`$docker_path port $config 22`"
635 split=(${address//:/ })
636 exec ssh -o StrictHostKeyChecking=no root@${split[0]} -p ${split[1]}
637 else
638 echo "$config is not running!"
639 exit 1
640 fi
641 ;;
642
643 stop)
644 run_stop
645 exit 0
646 ;;
647
648 logs)
649
650 $docker_path logs $config
651 exit 0
652 ;;
653
654 restart)
655 run_stop
656 run_start
657 exit 0
658 ;;
659
660 start)
661 run_start
662 exit 0
663 ;;
664
665 rebuild)
666 if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
667 echo "Ensuring discourse docker is up to date"
668
669 git remote update
670
671 LOCAL=$(git rev-parse @)
672 REMOTE=$(git rev-parse @{u})
673 BASE=$(git merge-base @ @{u})
674
675 if [ $LOCAL = $REMOTE ]; then
676 echo "Discourse Docker is up-to-date"
677
678 elif [ $LOCAL = $BASE ]; then
679 echo "Updating Discourse Docker"
680 git pull || (echo 'failed to update' && exit 1)
681 exec /bin/bash $0 $@
682
683 elif [ $REMOTE = $BASE ]; then
684 echo "Your version of Discourse Docker is ahead of origin"
685
686 else
687 echo "Discourse Docker has diverged source, this is only expected in Dev mode"
688 fi
689
690 fi
691
692 set_existing_container
693
694 if [ ! -z $existing ]
695 then
696 echo "Stopping old container"
697 (
698 set -x
699 $docker_path stop -t 10 $config
700 )
701 fi
702
703 run_bootstrap
704
705 if [ ! -z $existing ]
706 then
707 echo "Removing old container"
708 (
709 set -x
710 $docker_path rm $config
711 )
712 fi
713
714 run_start
715 exit 0
716 ;;
717
718
719 destroy)
720 (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
721 exit 0
722 ;;
723 esac
724
725 usage